import java.util.ArrayList;

/**
 * Die Klasse Kante repraesentiert Kanten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Kanten bereit.
 * 
 * @author claus albowski
 * @version Juni 2015
 */
public class Kante
implements Comparable  // ermoeglicht das automatische Sortieren mit sort()
{
    // Klassenvariable
    private static ArrayList<Kante> kantenListe = new ArrayList<Kante>();
    // Klassenmethode
    // Instanzvariable
    private Knoten p1,p2;
    private double kantenBewertung;
    
    /**
     * Konstruktor fuer Objekte der Klasse Kante,
     * in dieser Version als gerichtete Kanten
     * 
     * Bei den Konten werden nur die ausgehenden Kanten gespeichert
     */
    public Kante(Knoten p1, Knoten p2, double kantenBewertung){
        this.p1=p1;
        this.p2=p2;
        this.kantenBewertung = kantenBewertung;
        p1.neueKante(this);
        kantenListe.add(this);
    }
    
    //private static void neueKante(Kante k){ kantenListe.add(k); }
    public static Kante gibKante(int i){ return kantenListe.get(i); }
    public static int gibAnzahl() { return kantenListe.size(); }
    public static void loescheKanten(){
        while (! kantenListe.isEmpty()) Kante.entferneKante(kantenListe.get(0));
    }
    
    /**
     * entfernt die uebergebene Kante aus der Kantenliste.
     */
    public static void entferneKante(Kante kante){
        kante.gibAusgangsKnoten().entferneKante(kante);
        kantenListe.remove(kante);
    }

    // Fuer das Interface  Comparable notwendige Methode:
    public int compareTo(Object k) {
        if (gibBewertung()<((Kante)k).gibBewertung()) return -1;
        else if (gibBewertung()>((Kante)k).gibBewertung()) return 1;
        else return 0;
    }
    
    /**
     * get-Methoden fuer die Knoten
     */
    public Knoten gibAusgangsKnoten() { return p1; }
    public Knoten gibZielKnoten() { return p2; }
    
    /**
     * gibt die Laenge der Kante  zurueck.
     */
    public double gibBewertung(){
        return kantenBewertung;
    }
}
